var Keyconfig, Shortcuts, events,
  __hasProp = {}.hasOwnProperty,
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

Keyconfig = require('keyconfig');

events = require('events');

require('mousetrap');

require('mousetrap-global-bind');

module.exports = Shortcuts = (function(_super) {
  __extends(Shortcuts, _super);

  function Shortcuts(defaults) {
    var transform;
    if (defaults == null) {
      defaults = {};
    }
    this.config = new Keyconfig(defaults);
    this.config.on('change', function(collection, model) {
      return this.emit('change', collection, model);
    });
    this._numListeners = this.config.reduce(function(acc, x) {
      acc[x.name] = 0;
      return acc;
    }, {});
    this._listeners = {};
    transform = (function(_this) {
      return function(event) {
        var collection, collectionName, eventName, _ref;
        _ref = event.split(':'), eventName = _ref[0], collectionName = _ref[1];
        if (eventName !== 'key' || !(collection = _this.get(collectionName))) {
          return void 0;
        }
        return collection;
      };
    })(this);
    this.on('newListener', (function(_this) {
      return function(event) {
        var collection;
        if (!(collection = transform(event))) {
          return void 0;
        }
        if (++_this._numListeners[collection.name] === 1) {
          return _this._bind(collection);
        }
      };
    })(this));
    this.on('removeListener', (function(_this) {
      return function(event) {
        var collection;
        if (!(collection = transform(event))) {
          return void 0;
        }
        if (--_this._numListeners[collection.name] === 0) {
          return _this._unbind(collection);
        }
      };
    })(this));
    Shortcuts.__super__.constructor.call(this);
  }

  Shortcuts._osIndex = /(Mac|iPhone|iPod|iPad)/i.test(window.navigator.platform) ? 1 : 0;

  Shortcuts.prototype._bind = function(collection) {
    var index, _base, _name;
    index = ((_base = this._listeners)[_name = collection.name] || (_base[_name] = {}));
    return collection.each((function(_this) {
      return function(model) {
        var bindings, cb, listeners, sequence, _i, _len, _name1, _ref;
        bindings = [].concat(model.binding[Shortcuts._osIndex]).filter(Boolean);
        if (bindings.length) {
          listeners = (index[_name1 = model.name] || (index[_name1] = []));
          for (_i = 0, _len = bindings.length; _i < _len; _i++) {
            sequence = bindings[_i];
            cb = function(e) {
              return _this.emit("key:" + collection.name, e, collection, model);
            };
            listeners.push({
              sequence: sequence,
              cb: cb
            });
            if (((_ref = model.options) != null ? _ref.global : void 0) === true) {
              Mousetrap.bindGlobal(sequence, cb);
            } else {
              Mousetrap.bind(sequence, cb);
            }
          }
        }
      };
    })(this));
  };

  Shortcuts.prototype._unbind = function(collection) {
    var index, key, listener, listeners;
    index = this._listeners[collection.name];
    for (key in index) {
      listeners = index[key];
      while ((listener = listeners.pop()) != null) {
        Mousetrap.unbind(listener.sequence, listener.cb);
      }
      delete index[key];
    }
    delete this._listeners[collection.name];
  };

  Shortcuts.prototype.get = function(collectionName, modelName) {
    var collection, model;
    collection = this.config.find({
      name: collectionName
    });
    if (!modelName || (modelName && !collection)) {
      return collection;
    } else {
      model = collection.find({
        name: modelName
      });
      return model;
    }
  };

  return Shortcuts;

})(events.EventEmitter);
